// BiosphereIV.wdl
//--------------------------------------------------------------------
// PATHS
//--------------------------------------------------------------------

// resources
path ".\\Wads";
path ".\\Sounds";
path ".\\Models";
path ".\\Entities";
path ".\\Bitmaps";

// Levels
string world_str = <BiosphereIV.wmb>; // level string

// Bmaps
bmap pcxArrow = <arrow1.pcx>; // pointer arrow
bmap pcxEnterName = <entername.pcx>;
bmap pcxEntry = <entry.pcx>;
bmap pcxHost = <host.pcx>;
bmap pcxJoin = <join.pcx>;
bmap pcxMain = <main.pcx>;
bmap pcxServer = <server.pcx>;
bmap pcxSingle = <single.pcx>;
//bmap pcxOfficerMdl = <officer_mdl.pcx>;
//bmap pcxNuclearMdl = <nuclear_mdl.pcx>;
//bmap pcxBioMdl = <bio_mdl.pcx>;
bmap pcxLan = <lan.pcx>;
bmap pcxIp = <ip.pcx>;
bmap pcxEnterIp = <enterip.pcx>;
bmap pcxWindow = <window.pcx>;
bmap pcxFullScreen = <fullscreen.pcx>;


// Fonts
font fnt_century12	= <Centur12.pcx>,16,20; // Century12 font

var bat_set;

string strEntryLine[16];
string strBatCommand;
string strCommandLine;
string strIP;
string strGameFile = <multiplayer.exe>;

// text to display this player's health
text txtName 
{
	pos_x = 365;
	pos_y = 215;
	layer = 30;
	font fnt_century12;
	string strEntryLine;
}

text txtIp 
{
	pos_x = 365;
	pos_y = 215;
	layer = 30;
	font fnt_century12;
	string strIP;
}

// Panels
panel pnlMain
{
	bmap = pcxMain;
	layer = 20;	
	pos_x = 0;
	pos_y = 0;
	flags = overlay,visible,refresh;
}

panel pnlEnterName
{
	bmap = pcxEnterName;
	layer = 21;	
	pos_x = 155;
	pos_y = 200;
	flags = overlay,visible,refresh;
}

panel pnlEnterIp
{
	bmap = pcxEnterIp;
	layer = 21;	
	pos_x = 155;
	pos_y = 200;
	flags = overlay,refresh;
}

panel pnlEntry
{
	bmap = pcxEntry;
	layer = 21;	
	pos_x = 355;
	pos_y = 200;
	flags = overlay,visible,refresh;
}

panel pnlSingle
{
	bmap = pcxSingle;
	layer = 21;	
	pos_x = 25;
	pos_y = 200;
	on_click = single_player;
	flags = overlay,refresh;
}

panel pnlServer
{
	bmap = pcxServer;
	layer = 21;	
	pos_x = 225;
	pos_y = 200;
	on_click = dedicated_server;
	flags = overlay,refresh;
}

panel pnlHost
{
	bmap = pcxHost;
	layer = 21;	
	pos_x = 425;
	pos_y = 200;
	on_click = host;
	flags = overlay,refresh;
}

panel pnlJoin
{
	bmap = pcxJoin;
	layer = 21;	
	pos_x = 625;
	pos_y = 200;
	on_click = join;
	flags = overlay,refresh;
}

panel pnlLan
{
	bmap = pcxLan;
	layer = 21;	
	pos_x = 200;
	pos_y = 200;
	on_click = join_lan;
	flags = overlay,refresh;
}

panel pnlIp
{
	bmap = pcxIP;
	layer = 21;	
	pos_x = 400;
	pos_y = 200;
	on_click = join_ip;
	flags = overlay,refresh;
}

panel pnlWindow
{
	bmap = pcxWindow;
	layer = 21;	
	pos_x = 200;
	pos_y = 200;
	on_click = window_mode;
	flags = overlay,refresh;
}

panel pnlFullScreen
{
	bmap = pcxFullScreen;
	layer = 21;	
	pos_x = 400;
	pos_y = 200;
	on_click = fullscreen_mode;
	flags = overlay,refresh;
}


// The engine starts in the resolution given by the following vars.
var video_mode = 7; // screen size 800 x 600
var video_screen = 1; // start settings for Fullscreen
var mouse_mode = 2; // does not effect forces

function main()
{
	level_load(world_str); // load level
	sleep(.5); // make sure level is loaded
	
	txtName.visible = on;
	Inkey(strEntryLine);
	txtName.visible = Off;
	pnlEntry.visible = OFF;
	pnlEnterName.visible = OFF;
	
	mouse_on();
	
	sleep(.5);
	pnlWindow.visible = on;
	pnlFullScreen.visible = on; 
	
	while (!bat_set)
	{
		wait(1);
	}
	
	pnlWindow.visible = off;
	pnlFullScreen.visible = off; 
	
	sleep(.5);
	
	pnlSingle.visible = on;
	pnlServer.visible = on;
	pnlHost.visible = on;
	pnlJoin.visible = on;
	
	
}

// Desc: switches the mouse on
function mouse_on()
{
	MOUSE_MAP = pcxArrow;
	while(MOUSE_MODE > 0)
	{
		MOUSE_POS.X = POINTER.X;
		MOUSE_POS.Y = POINTER.Y;
		wait(1); 		      // now move it over the screen
	}
}

function connection_type_off()
{
	pnlSingle.visible = off;
	pnlServer.visible = off;
	pnlHost.visible = off;
	pnlJoin.visible = off;
}

function window_mode()
{
	str_cpy(strBatCommand, "-wnd ");
	bat_set = 1;
}

function fullscreen_mode()
{
	str_cpy(strBatCommand, "");
	bat_set = 1;
}

function single_player()
{
	connection_type_off();
	str_cpy(strCommandLine, "-pl ");
	str_cat(strCommandLine, strEntryLine);
	str_cat(strBatCommand, strCommandLine); 
	exec(strGameFile, strBatCommand);
	exit;
}

function dedicated_server()
{
	connection_type_off();
	exec (strGameFile, "-sv -sn LocoTutBeta4");
	exit;
}

function host()
{
	connection_type_off();
	str_cpy(strCommandLine, "-cl -sv -sn LocoTutBeta4 -pl ");
	str_cat(strCommandLine, strEntryLine); 
	str_cat(strBatCommand, strCommandLine); 
	exec(strGameFile, strBatCommand);
	exit;
}

function join_lan()
{
	connection_type_off();
	str_cpy(strCommandLine, "-cl -sn LocoTutBeta4 -pl ");
	str_cat(strCommandLine, strEntryLine);
	str_cat(strBatCommand, strCommandLine); 
	exec(strGameFile, strBatCommand);
	exit;
}

function join_ip()
{
	pnlLan.visible = off;
	pnlIp.visible = off;
	txtIp.visible = on;
	pnlEntry.visible = on;
	pnlEnterIp.visible = on;
	Inkey(strIP);
	str_cpy(strCommandLine, "-cl -sn LocoTutBeta4 -ip ");
	str_cat(strCommandLine, strIp);
	str_cat(strCommandLine," -pl ");
	str_cat(strCommandLine,strEntryLine);
	str_cat(strBatCommand, strCommandLine); 
	exec(strGameFile, strBatCommand);
	exit;
	
}

function join()
{
	connection_type_off();
	pnlLan.visible = on;
	pnlIp.visible = on;	
}

function exit_game()
{
	exit;
}

on_esc = exit_game;