// multiplayer.wdl
//*******************************************************************
//
// Locoweed's Multiplayer Tutorial I
//
// Name: Bioshere IV: Lunar Mania
//
// Date Created: 09/15/04
// Last Update: 10/25/04
//
// Author: Frederick "Locoweed" Sims and You
//
// Description: Multiplayer Deathmatch Shooter made for Conitec's
// 2004 Tutorial Contest
//
// Rules of Use: Freeware. Credits appreciated.
//
// Contibutions:
//
// Models:
// lightgun model: Kai Kieschnick
// rifle model: created by logaan (Daniel van Westen)
// webmaster@lunatic-software.de
// www.lunatic-software.de
//
// Textures:
//basewalls: Gay "Bopete" Crawford
//basewalls: Gay "Bopete" Crawford
//stars: Gay "Bopete" Crawford
//crators: Gay "Bopete" Crawford
//planet: Gay "Bopete" Crawford
//
// Scripts:
// Server Disconnection Check on Client written by SchokoKeks
// Skip Old Local Procedures (A6.31 Bug) written by Giorgi3
//
// Executive Beta Tester: imagineer - thanks for doing tutorial test :)
//
// Beta Testers Online: giorgi3, ZombieWoof, Juppp, Grimber, danthaman015
// and Rhuarc.
//
//********************************************************************

//--------------------------------------------------------------------
// PATHS
//--------------------------------------------------------------------
// resources
path ".\\Wads";
path ".\\Sounds";
path ".\\Models";
path ".\\Entities";
path ".\\Bitmaps";

//--------------------------------------------------------------------
// DEFINES
//--------------------------------------------------------------------
// Boolean
define FALSE, 0;
define TRUE, 1;


define MAX_CONNECTIONS, 64; // maximum number of people who can be connected to server

// Profession Types
define PROF_NUCLEAR_SCIENTIST, 1; // Nuclear scientist
define PROF_BIOLOGICAL_SCIENTIST, 2; // Biological scientist
define PROF_OPERATIONS_OFFICER, 3; // Operations officer

// Profession speeds
define PROF_NUCLEAR_SPEED, 11; // Speed of nuclear scientist
define PROF_BIOLOGICAL_SPEED, 12; // Speed of biological scientist
define PROF_OFFICER_SPEED, 13; // Speed of operations officer

// Profession's max health
define PROF_NUCLEAR_MAX_HP, 50;
define PROF_BIOLOGICAL_MAX_HP, 75;
define PROF_OFFICER_MAX_HP, 100;


// Profession's Armor Classes
// if player is hit by projectile, roll 20 sided die, if d20 >= AC, do damage
define PROF_NUCLEAR_AC, 4;
define PROF_BIOLOGICAL_AC, 6;
define PROF_OFFICER_AC, 8;

// Movement Defines
define PLAYER_SPEED_TURN, 6; // how fast a player rotates

// Weapon Types
define WEAPON_NUCLEAR_ROD, 1; // Nuclear Scientist weapon
define WEAPON_PHOTOSYNTHESIS_EMULATOR, 2; // Biological Scientiest weapon
define WEAPON_COMPRESSION_RIFLE, 3; // Operation Officer weapon


// Animation States
define ANIMATION_STATE_STAND, 0;
define ANIMATION_STATE_WALK, 1;
define ANIMATION_STATE_RUN, 2;
define ANIMATION_STATE_ATTACK, 3;

// Animation Speeds
define PLAYER_ANIM_WALK_SPEED, 6; // animation speed for walk
define PLAYER_ANIM_RUN_SPEED, 8; // animation speed for run
define PLAYER_ANIM_BLEND_SPEED, 10; // speed for blend

// Powerup Types
define POWER_UP_USED_NUCLEAR_FUEL ,1; // Ammunition for Nuclear Rod.
define POWER_UP_PHOTOSYNTHESIS_JELLY, 2; // Ammunition for Photosythesis Emulator.
define POWER_UP_AMMUNITION_CARTRIDGE, 3; // Ammunition for Compression Rifle.
define POWER_UP_LUNAR_CANDY, 4; // lunar candy power-up

// Power-up defines
define MAX_POWERUP_TYPE_IN_LEVEL, 10; // Maximum number of any power-up type

// Weapon recharge
define WEAPON_RECHARGE_DELAY, 25; // reload time in frames

// Projectile speed
define PROJECTILE_SPEED, 30; // speed of projectiles

// Player's grace time in frames (cannot be hit upon creation)
define PLAYER_GRACE_TIME, 600;

// Ammunition life_spans
define AMMO_LIFESPAN_NUCLEAR, 200; // lifespan of raditiaon beam
define AMMO_LIFESPAN_EMULATOR, 110; // lifespan of petri-dish
define AMMO_LIFESPAN_RIFLE, 135; // lifespan of bullet

// Local Effects
define EFFECT_HIT_EXPLOSION, 1; // big explosion on hit
define EFFECT_RICOCHET_EXPLOSION, 2; // little explosion on ricochet

// Ammunition Misc
define AMMO_GAME_START, 10; // The number of rounds each player starts game with
define AMMO_MAX, 50; // maximum ammunition a entity can have // Ammunition at Game Start

//--------------------------------------------------------------------
// SKILL DEFINITIONS
//--------------------------------------------------------------------
define player_number, skill1; // player number this entity owned by
define lunar_psychosis_rating, skill2; // score
define profession, skill3; // entity's profession
define speed, skill4; // move speed
define health, skill5; // health
define max_health, skill6; // max health of entity
define armor_class, skill7; // armor class of ent
define force_x, skill8; // current forces for this ent
define force_y, skill9;
define force_z, skill10;
define current_anim_percent, skill11; // current animation percent
define blend_anim_percent,skill12; // blending animation percent
define animation_state, skill13; // animation state
define prev_anim_state, skill14; // previous animation state for blending
define weapon, skill15; // weapon ID this ent wields
define power_up_type, skill16; // power up type of this ent if a power up
define ammunition_remaining, skill17; // ammunition entity has left
define damage_die_1, skill18; // random damage of die 1
define damage_die_2, skill19; // random damage of die2
define firing_weapon, skill20; // TRUE if ent firing weapon
define life_span, skill21; // projectile life_span
define animation_attack_life, skill22; // how long to run attack anim on fire
define grace_time, skill23; // time left in ent's grace period
define explosion_normal_x, skill24; // normal vec used by projectile for effect
define explosion_normal_y, skill25;
define explosion_normal_z, skill26;
define owned_by_hdl, skill27; // owner of this ent (used for projectile)

//--------------------------------------------------------------------
// RESOURCES
//--------------------------------------------------------------------

// Levels
string world_str = <multiplayer.wmb>; // level string

//Models
string str_cbabe = <cbabe.mdl>; // CBabe Model
string str_warlock = <blue_warlock.mdl>; // Blue Warlock Model
string str_guard = <red_guard.mdl>; // Red Guard Model
string str_rifle = <rifle.mdl>; // compression rifle model
string str_nuclear_rod = <nuclearrod.mdl>; // nuclear rod mdl
string str_emulator = <lightgun.mdl>; // photosynthesis emulator model
string str_ammo_cartridge = <ammocartridge.mdl>; //ammo cartridge model
string str_nuclear_fuel = <nuclearfuel.mdl>; // nuclear fuel model
string str_photo_jelly = <photojelly.mdl>; // photosynthesis jelly model
string str_lunar_candy = <lunarcandy.mdl>; // lunar candy model
string str_bullet = <bullet.mdl>; // bullet model
string str_petri_dish = <petridish.mdl>; // petri_dish
string str_radiation_beam = <radiationbeam.mdl>; // radiation beam model


// Fonts
font fnt_century12 = <Centur12.pcx>,16,20; // Century12 font

// Sounds
sound snd_radiation_beam = <radiationbeam.wav>;
sound snd_emulator = <emulator.wav>;
sound snd_rifle = <rifle.wav>;
sound snd_damage = <damage.wav>;
sound snd_no_damage = <nodamage.wav>;
sound snd_power_up = <powerup.wav>;

// Bmaps
bmap pcxArrow = <arrow.pcx>; // pointer arrow
bmap bmpNuclear = <nuclear.bmp>; // nuclear scientiest panel
bmap bmpBiological = <biological.bmp>; // bio scientist panel
bmap bmpOfficer = <officer.bmp>; // op officer panel
bmap pcxTitle = <title.pcx>; // Title panel
bmap pcxSelect = <select.pcx>; // Selection panel
bmap pcxChat = <Chat.pcx>; // Chat Panel
bmap spark_map,<particle.pcx>; // bitmap used for sparks
bmap* scatter_map = spark_map;


//--------------------------------------------------------------------
// Variables
//--------------------------------------------------------------------

// Engine Variable
var fps_max = 60; // lock fps at 60 for all players
var fps_lock = ON;
var dplay_smooth = 0; // dplay_smooth is causing too much overshoot and jerks
// The engine starts in the resolution given by the following vars.
var video_mode = 7; // screen size 800x600
var video_screen = 1; // start settings for Fullscreen
var mouse_mode = 2; // does not effect forces

// Game Variables
var people_connected = 0; // number of people connected to server
var number_of_players = 0; // # of players in game
var server_says_start = FALSE; // client holds creating entity until server says go
var profession_ID; // players profession ID
var temp_loc[3]; // temp vector
var vecFrom[3]; // temp vectors
var vecTo[3];
var profession_not_set = TRUE; // don't start game until profession set
var force[3]; // temp forces
var nuclear_fuel_count; // number of nuclear fuel power ups in level
var ammo_cartridge_count; // number ammo cartridges in level
var photo_jelly_count; // number of photo jellies in level
var lunar_candy_count; // number of lunar candies in level
var server_restart; // server died, server go back to profession selection
var client_restart; // client died, client go back to profession selection
var start_cam_pos[3]; // on death revert back to start cam position
var start_cam_pan[3];
var weapon_recharge_count = WEAPON_RECHARGE_DELAY; // reload time
var send_server_player; // tells server to send his player ent to all client
var effect_pos[3]; // position to do local effect
var effect_normal[3]; // normal for local explosion
var do_effect_type; // type of effect to do locally
var player_number_quit; // number of player who quit or was killed

//--------------------------------------------------------------------
// Strings
//--------------------------------------------------------------------
// display strings
string str_people_connected; // number of people connected to server
string str_temp; // temp string
string str_player_num; // string to hold player number
string str_number_of_players; // string to hold number of players
string str_player_name; // player name for text display
string str_ammo_remaining; // ammunition count of this player
string str_health; // player's health string
string str_lunar_psychosis_rating; // score
string str_latency;
string str_bps;

// message strings
string str_status_message; // tells player game status, Loading & Grace Period

// Chat strings
string strChat0[100]; // Chat entries
string strChat1[100];
string strChat2[100];
string strChat3[100];
string strChat4[100];
string strChat5[100];
string strChat6[100];
string strChat7[100];
string strChat8[100];
string strChatEntry[80]; // current chat entry
string strSendChat[100]; // chat to send

//--------------------------------------------------------------------
// Entity Pointers
//--------------------------------------------------------------------
entity* ptrTempEnt; // temp pointer to a entity
entity* ptrOwner; // pointer to owner of an entity
entity* ptrTempOwner; // temp pointer to owner of an entity

//--------------------------------------------------------------------
// Text
//--------------------------------------------------------------------
// text to display the number of people connected to game
text txt_people_connected
{
	pos_x = 0;
	pos_y = 65;
	layer = 15;
	font fnt_century12;
	string str_people_connected;
}

// text to display this player's number
text txt_player_number
{
	pos_x = 0; // set in init_display
	pos_y = 5;
	layer = 15;
	font fnt_century12;
	string str_player_num;
}

// text to display the number of players currently in game
text txt_number_of_players
{
	pos_x = 0; // set in init_display
	pos_y = 35;
	layer = 15;
	font fnt_century12;
	string str_number_of_players;
}

// text for chat panel
text txtChat
{
	pos_x = 2;
	pos_y = 0;
	layer = 30;
	font _a4font;
	strings = 9;
	string = strChat0, strChat1, strChat2, strChat3, strChat4,
	strChat5, strChat6, strChat7, strChat8;
}

// text for chat entry
text txtChatEntry
{
	pos_x = 2;
	pos_y = 0;
	layer = 30;
	font _a4font;
	string strChatEntry;
}

// text to display this player's name
text txt_player_name
{
	pos_x = 5;
	pos_y = 5;
	layer = 15;
	font fnt_century12;
	string str_player_name;
	flags = visible;
}

// text to display this player's ammunition remaining
text txt_ammo_remaining
{
	pos_x = 5;
	pos_y = 95;
	layer = 15;
	font fnt_century12;
	string str_ammo_remaining;
}

// text to display this player's health
text txt_health
{
	pos_x = 5;
	pos_y = 65;
	layer = 15;
	font fnt_century12;
	string str_health;
}

// text that tells player game status
text txt_status_message
{
	pos_x = 0; // set in init_display
	pos_y = 0; // set in init_display
	layer = 15;
	font fnt_century12;
	string str_status_message;
}

// text to display this player's score
text txt_lunar_psychosis_rating
{
	pos_x = 5;
	pos_y = 35;
	layer = 15;
	font fnt_century12;
	string str_lunar_psychosis_rating;
}

// text for latency
text txt_latency
{
	pos_x = 0; // set in init_display()
	pos_y = 95;
	layer = 15;
	font fnt_century12;
	string str_latency;
}

// text for bytes per second
text txt_bps
{
	pos_x = 0; // set in init_display()
	pos_y = 125;
	layer = 15;
	font fnt_century12;
	string str_bps;
}


//--------------------------------------------------------------------
// Panels
//--------------------------------------------------------------------
// Profession selection panels
panel pnlNuclear
{
	bmap = bmpNuclear;
	layer = 21;
	pos_x = 0;
	pos_y = 0;
	on_click = set_prof_nuclear;
	flags = overlay, transparent, refresh;
}

panel pnlBiological
{
	bmap = bmpBiological;
	layer = 21;
	pos_x = 0;
	pos_y = 0;
	on_click = set_prof_biological;
	flags = overlay, transparent, refresh;
}

panel pnlOfficer
{
	bmap = bmpOfficer;
	layer = 21;
	pos_x = 0;
	pos_y = 0;
	on_click = set_prof_officer;
	flags = overlay, transparent, refresh;
}

// panel title
panel pnlTitle
{
	bmap = pcxTitle;
	layer = 18;	
	pos_x = 0;
	pos_y = 0;
	flags = overlay,transparent,refresh;
}

// panel select
panel pnlSelect
{
	bmap = pcxSelect;
	layer = 18;	
	pos_x = 0;
	pos_y = 0;
	flags = overlay,transparent,refresh;
}

// chat panel
panel pnlChat
{
	bmap = pcxChat;
	layer = 18;
	pos_x = 0;
	pos_y = 0;
	flags = overlay,transparent,refresh;
}


//--------------------------------------------------------------------
// MAIN
//--------------------------------------------------------------------
function main()
{	

	randomize(); // set random seed
	
	// if not a single player game, wait for connection
	ifdef server;
		while(connection== 0) {wait(1);} // wait until level loaded and connection set
	endif;

	ifdef client;
		while(connection== 0) {wait(1);} // wait until level loaded and connection set
	endif;
	
	level_load(world_str); // load level
	sleep(.5); // make sure level is loaded
	
	vec_set(start_cam_pos,camera.pos); // save camera's original poistion for death
	vec_set(start_cam_pan,camera.pan);
	
	// had to place check for power ups here incase server doesn't choose professiion
	// until after clients choose theirs
	// if not client, create random power-ups (if server, host, or single-player)
	if(connection != 2)
	{
		spawn_power_ups(); // continually create power-ups
	}

	if(connection == 2) // client?
	{
		while (server_says_start == FALSE) // wait for server to signal ok to continue
		{
			wait(1);
		}
	}

	
	// if host, count yourself as a connection
	if (connection == 3)
	{
		people_connected = 1;
	}
	
	restart_main: // on death restart here

	vec_set(camera.pos,start_cam_pos); // get original camera position
	vec_set(camera.pan,start_cam_pan);
	
	check_server_disconnect(); // continually checks is server is gone

	// if dedicated server skip these
	if (connection != 1)
	{
		
		init_display(); // initiliaze text positions as necessary
		display_info(); // continually display any information we want to show
		
		mouse_mode = 2; // mouse with no force changes
		mouse_on(); // turn mouse on
		
		// turn off all text not needed for profession selection
		txt_health.visible = OFF;
		txt_ammo_remaining.visible = OFF;
		txt_player_number.visible = OFF;
		txt_lunar_psychosis_rating.visible = OFF;
		
		//display profession selection panels
		pnlNuclear.visible = ON;
		pnlBiological.visible = ON;
		pnlOfficer.visible = ON;
		pnlTitle.visible = ON;
		pnlSelect.visible = ON;

		
		// if not single player mode, display multiplayer information
		if(connection)
		{
			txt_people_connected.visible = ON;
			txt_number_of_players.visible = ON;
			txt_player_number.visible = ON;
			txt_bps.visible = ON;
			txt_latency.visible = ON;
		}
		
		// wait for a profession to be selected
		while(profession_not_set)
		{
			wait(1);
		}
		
		mouse_off(); // turn mouse off

		// hide profession selection panels
		pnlNuclear.visible = OFF;
		pnlBiological.visible = OFF;
		pnlOfficer.visible = OFF;
		pnlTitle.visible = OFF;
		pnlSelect.visible = OFF;

	
		create_player(); // create player
		move_camera(); // call simple 3rd Person chase camera
		input_scan(); // get inputs
		init_chat(); // intitialize chat variables
		reload_weapon(); // continually recharges weapon
		local_effect(); // continually check for effect to be run on client
		
		// wait for this player's entity to be created
		while(!player)
		{
			wait(1);
		}
		
		// display player specific text
		txt_health.visible = ON;
		txt_ammo_remaining.visible = ON;
		txt_player_number.visible = ON;
		txt_lunar_psychosis_rating.visible = ON;

		
		// display loading message
		str_cpy(str_status_message, "Initializing Player...");
		txt_status_message.visible = ON;

		// after player has a weapon we can continue to
		// grace period message
		while(player.weapon == 0)
		{
			wait(1);
		}
		
		str_cpy(str_status_message, "Grace Period Active");


	}
	
	// main game loop
	while(1)
	{
		
		if((!player) && (connection!=1)) // if player is dead restart profession selection
		{
			profession_not_set = TRUE; // no profession until select again
			goto(restart_main);
		}

		
		//dedicated server skips this
		if (connection != 1)
		{
			// if grace period over, hide message
			if (player.grace_time == 0)
			{
				txt_status_message.visible = OFF;
			}
		}


		wait(1);
	}

}

function check_server_disconnect()
{
	while(1)
	{
		// server disconnected so quit client too
		if (dplay_latency == 0 && dplay_bps == 0 && connection == 2)
		{
			exit;
		}
		wait(1);
	}
}


// Desc: switches the mouse on
function mouse_on()
{
	MOUSE_MAP = pcxArrow;
	while(MOUSE_MODE > 0)
	{
		MOUSE_POS.X = POINTER.X;
		MOUSE_POS.Y = POINTER.Y;
		wait(1); // now move it over the screen
	}
}

// Desc: switches the mouse off
function mouse_off()
{
	MOUSE_MODE = 0;
}


//--------------------------------------------------------------------
// Function Server_Called(): server was called
//--------------------------------------------------------------------
function server_called()
{
	// if new player connected, increment people connected
	// and tell him it's ok to continue

	if ((event_type == event_join) && (people_connected < MAX_CONNECTIONS))
	{
		ifdef server;
			people_connected += 1; // another person connected
			send_var(people_connected); // send number of people connected
			server_says_start = TRUE; // send it's ok to go to newest client
			send_var(server_says_start); // send start message
		endif; // ifdef server
	}

	// some one disconnected
	if (event_type == event_leave)
	{
		ifdef server;
			people_connected -= 1; // one less person connected to server
			send_var(people_connected); // send number of people connected
		endif;
	}
	
	// chat stuff
	if (event_type == event_string)
	{
		if (!str_cmp(strSendChat,""))
		{
		ifdef server;
			send_string(strSendChat); // send string to clients
			str_cpy(strChat0, strChat1); // move old chat entries up 1
			str_cpy(strChat1, strChat2);
			str_cpy(strChat2, strChat3);
			str_cpy(strChat3, strChat4);
			str_cpy(strChat4, strChat5);
			str_cpy(strChat5, strChat6);
			str_cpy(strChat6, strChat7);
			str_cpy(strChat7, strChat8);
			str_cpy(strChat8, strSendChat);
			str_cpy(strSendChat,"");
		endif;
		}
	}
}

//--------------------------------------------------------------------
// Function Client_Called(): client was called
//--------------------------------------------------------------------
function client_called()
{
	// string event
	if (event_type == event_string)
	{
		// chat entry sent from server, process
		if (!str_cmp(strSendChat,""))
		{
			str_cpy(strChat0, strChat1); // move old chat entries up 1
			str_cpy(strChat1, strChat2);
			str_cpy(strChat2, strChat3);
			str_cpy(strChat3, strChat4);
			str_cpy(strChat4, strChat5);
			str_cpy(strChat5, strChat6);
			str_cpy(strChat6, strChat7);
			str_cpy(strChat7, strChat8);
			str_cpy(strChat8, strSendChat);
			str_cpy(strSendChat,"");
		}
	}
}



//--------------------------------------------------------------------
// PLAYER EVENTS
//--------------------------------------------------------------------
function player_events()
{
	// client disconnected
	if (EVENT_TYPE == EVENT_DISCONNECT)
	{
		number_of_players -= 1; // decrement number of players
		// Go through all entities, any player# that was above mine, decrement his player number
		you = ent_next(NULL);
		while(you != NULL)
		{
			if(you.player_number > my.player_number)
			{
				you.player_number -= 1;
				send_skill(you.player_number, SEND_ALL); // send new player#
			}
			you =ent_next(you);
		}
		send_var(number_of_players); // let everyone know new number of players
		ent_remove(me); // remove ent of player that quit
	}
}

//--------------------------------------------------------------------
// WEAPON_FUNCTION - moves weapon with player or NPC
//--------------------------------------------------------------------
function weapon_local()
{
	my.dynamic = ON; // let server know this entity is not static - do not remove
	my.passable = ON; // make passable so can ignore during player move
	
	// temporary code for what I think is a Bug in Server Mode A6.31
	// you can remove this in later versions of 3DGS I believe
	if(!my.x && !my.y && !my.z)
	{
		return;
	}

	
	while(you)
	{
	
		if (you.weapon == WEAPON_PHOTOSYNTHESIS_EMULATOR)
		{
			vec_for_vertex(my.X,you,2); // get position of weapon
			vec_set(my.pan,you.pan); // set pan to owner's pan
			my.pan -= 10; // adjust weapon so player can see it better
		}
		if (you.weapon == WEAPON_NUCLEAR_ROD)
		{
			vec_for_vertex(my.X,you,9); // get position of weapon
			vec_set(my.pan,you.pan); // set pan to owner's pan
		}
		if (you.weapon == WEAPON_COMPRESSION_RIFLE)
		{
			vec_for_vertex(my.X,you,354); // get position of weapon
			vec_set(my.pan,you.pan); // set pan to owner's pan
		}
	
		wait(1);
	}
	remove(my); // remove weapon if owner does not exist any more
}


//--------------------------------------------------------------------
// DISPLAY INFO - continuously displays game information
//--------------------------------------------------------------------
function display_info()
{
	while(1)
	{
		str_cpy(str_player_name, "Player Name: ");
		str_cat(str_player_name, player_name);
		
		str_cpy(str_people_connected, "People Connected: ");
		str_for_num(str_temp, people_connected);
		str_cat(str_people_connected, str_temp);
		
		str_cpy(str_number_of_players, "Number of Players: ");
		str_for_num(str_temp, number_of_players);
		str_cat(str_number_of_players, str_temp);
		
		str_cpy(str_latency, "Latency: ");
		str_for_num(str_temp, dplay_latency);
		str_cat(str_latency, str_temp);
		
		str_cpy(str_bps, "BPS: ");
		str_for_num(str_temp, dplay_bps);
		str_cat(str_bps, str_temp);
		
		if (player != NULL) // player exist
		{
			str_cpy(str_player_num, "Player Number: ");
			str_for_num(str_temp, player.player_number);
			str_cat(str_player_num, str_temp);
			
			str_cpy(str_lunar_psychosis_rating, "Score (LPR): ");
			str_for_num(str_temp, int(player.lunar_psychosis_rating));
			str_cat(str_lunar_psychosis_rating, str_temp);
			
			str_cpy(str_health, "Health: ");
			str_for_num(str_temp, int(player.health));
			str_cat(str_health, str_temp);
			str_cat(str_health, "/");
			str_for_num(str_temp, player.max_health);
			str_cat(str_health, str_temp);
	
			str_cpy(str_ammo_remaining, "Ammunition Remaining: ");
			str_for_num(str_temp, player.ammunition_remaining);
			str_cat(str_ammo_remaining, str_temp);
			str_cat(str_ammo_remaining, "/");
			str_for_num(str_temp, AMMO_MAX);
			str_cat(str_ammo_remaining, str_temp);
		}
	
		wait(1);
	}
}

//--------------------------------------------------------------------
// MOVE_OFFICER - action for operations officer
//--------------------------------------------------------------------
action move_officer
{
	my.profession = PROF_OPERATIONS_OFFICER;
	move_player();
}

//--------------------------------------------------------------------
// MOVE_NUCLEAR - action for nuclear scientist
//--------------------------------------------------------------------
action move_nuclear
{
	my.profession = PROF_NUCLEAR_SCIENTIST;
	move_player();
}

//--------------------------------------------------------------------
// MOVE_BIOLOGICAL - action for biological scientist
//--------------------------------------------------------------------
action move_biological
{
	my.profession = PROF_BIOLOGICAL_SCIENTIST;
	move_player();
}

//--------------------------------------------------------------------
// Function Animate(): animate a entity
//--------------------------------------------------------------------
function animate()
{
	my.dynamic = ON; // let server know this entity is not static - do not remove
	proc_late(); // make sure forces set before we run animation
	
	// temporary code for what I think is a Bug in Server Mode A6.31
	// you can remove this in later versions of 3DGS I believe
	if(!my.x && !my.y && !my.z)
	{
		return;
	}

	
	while(my)
	{
		if (my.animation_state == ANIMATION_STATE_RUN)
		{
			my.current_anim_percent += PLAYER_ANIM_RUN_SPEED * time;
		}
		else
		{
			my.current_anim_percent += PLAYER_ANIM_WALK_SPEED * time;
		}	
	
		if( my.current_anim_percent > 100 )
		{
			my.current_anim_percent -= 100;
		}

		// do animation of current animation state
		if (my.animation_state == ANIMATION_STATE_WALK)
		{
			if(my.prev_anim_state != my.animation_state)
			{
				my.blend_anim_percent += PLAYER_ANIM_BLEND_SPEED * time;
				my.blend_anim_percent = min(my.blend_anim_percent,100);

				ent_blend("walk",0,my.blend_anim_percent);

				if(my.blend_anim_percent == 100)
				{
					my.current_anim_percent=0;

					ent_animate(me,"walk",my.current_anim_percent,ANM_CYCLE );
					my.prev_anim_state = my.animation_state;
					my.blend_anim_percent = 0;
				}
			}
			else
			{
				ent_animate( me, "walk", my.current_anim_percent, ANM_CYCLE);
			}
		}
		else
		{
			if (my.animation_state == ANIMATION_STATE_STAND)
			{
				if(my.prev_anim_state != my.animation_state)
				{
					my.blend_anim_percent += PLAYER_ANIM_BLEND_SPEED * time;
					my.blend_anim_percent = min(my.blend_anim_percent,100);
					
					ent_blend("stand",my.current_anim_percent,my.blend_anim_percent);
					if(my.blend_anim_percent == 100)
					{
						my.current_anim_percent=0;

						ent_animate(me,"stand",my.current_anim_percent,ANM_CYCLE );
						my.prev_anim_state = my.animation_state;
						my.blend_anim_percent = 0;
					}
				}
				else
				{
					ent_animate( me, "stand", my.current_anim_percent, ANM_CYCLE );
				}
			}
			else
			{
				if (my.animation_state == ANIMATION_STATE_RUN)
				{
					if(my.prev_anim_state != my.animation_state)
					{
						my.blend_anim_percent += PLAYER_ANIM_BLEND_SPEED * time;
						my.blend_anim_percent = min(my.blend_anim_percent,100);
				
						ent_blend("run",my.current_anim_percent,my.blend_anim_percent);
						if(my.blend_anim_percent == 100)
						{
							my.current_anim_percent=0;
				
							ent_animate(me,"run",my.current_anim_percent,ANM_CYCLE );
							my.prev_anim_state = my.animation_state;
							my.blend_anim_percent = 0;
						}
					}
					else
					{
						ent_animate( me, "run", my.current_anim_percent, ANM_CYCLE );
					}
				}
				else // attack
				{
					if(my.prev_anim_state != my.animation_state)
					{
						my.blend_anim_percent += PLAYER_ANIM_BLEND_SPEED * time;
						my.blend_anim_percent = min(my.blend_anim_percent,100);
				
						ent_blend("attack",my.current_anim_percent,my.blend_anim_percent);


						if (my.blend_anim_percent == 100)
						{
							my.current_anim_percent=0;

							ent_animate(me,"attack",my.current_anim_percent,ANM_CYCLE );
							my.prev_anim_state = my.animation_state;
							my.blend_anim_percent = 0;
						}
					}
					else
					{
						ent_animate( me, "attack", my.current_anim_percent, ANM_CYCLE );
					}
				}
			}
		}
		
		wait(1);
	}
}

//--------------------------------------------------------------------
// LOCAL_ACTIVITIES_NUCLEAR - performs local ativities for Nuke Scientist
//--------------------------------------------------------------------
function local_activities_nuclear()
{
	my.weapon = WEAPON_NUCLEAR_ROD; // set weapon type


	you = my; // save MY into YOU because weapon_local() needs to know who owner is
	// Attach correct weapon to player
	ent_createlocal(str_nuclear_rod, my.x, weapon_local); // created emulator at
																	// player position locally

	animate(); // do my animation locally
}

//--------------------------------------------------------------------
// LOCAL_ACTIVITIES_BIO - performs local ativities for Bio Scientist
//--------------------------------------------------------------------
function local_activities_bio()
{
	my.weapon = WEAPON_PHOTOSYNTHESIS_EMULATOR; // set weapon type
	
	you = my; // save MY into YOU because weapon_local() needs to know who owner is
	// Attach correct weapon to player
	ent_createlocal(str_emulator, my.x, weapon_local); // created emulator at
																	// player position locally


	animate(); // do my animation locally
}

//--------------------------------------------------------------------
// LOCAL_ACTIVITIES_NUCLEAR - performs local ativities for Op Officer
//--------------------------------------------------------------------
function local_activities_officer()
{
	my.weapon = WEAPON_COMPRESSION_RIFLE; // set weapon type
	
	you = my; // save MY into YOU because weapon_local() needs to know who owner is
	// Attach correct weapon to player
	ent_createlocal(str_rifle, my.x, weapon_local); // created emulator at
																// player position locally

	animate(); // do my animation locally
}

//--------------------------------------------------------------------
// Function Two_Dice_damage - rolls 2 dice stored in skills
//--------------------------------------------------------------------
function two_dice_damage()
{
	var random1 = 0; // random numbers
	var random2 = 0;
	var dam; // total damage
	
	// Also, my.damage_die1 should always be a positive number
	if ((my.damage_die_1 <= 0)&&(my.damage_die_2 <= 0)||(my.damage_die_1 <=0))
	// The below commented code is better, but would be harder to understand
	// it does the exact same thing as above though
	// if ((my.damage_die_1 <= 0)||(my.damage_die_2 < 0))
	{
		return(0);
	}
	
	random1 = int(random(my.damage_die_1)) + 1; // get roll die 1
	
	// we will give the ability to have 1 die damage by setting my.damage_die_2
	// to 0
	if (my.damage_die_2 != 0)
	{
		random2 = int(random(my.damage_die_2)) + 1; // get roll die 2
	}

	dam = random1 + random2; // get damage
	return (dam); // return damage
}

//--------------------------------------------------------------------
// Function Vec_Randomize(): randomize a vector for explosion
//--------------------------------------------------------------------
function vec_randomize(&vec,range)
{
	vec[0] = random(1) - 0.5;
	vec[1] = random(1) - 0.5;
	vec[2] = random(1) - 0.5;
	vec_normalize(vec, random(range));
}

//--------------------------------------------------------------------
// Function Part_Alphafade(): fade particle over time
//--------------------------------------------------------------------
function part_alphafade()
{
	my.alpha -= time+time;
	if (my.alpha <= 0) { my.lifespan = 0; }
}

//--------------------------------------------------------------------
// Function Effect_Explosion(): do an explosion
//--------------------------------------------------------------------
function effect_explosion()
{
	vec_randomize(temp_loc,30);
	vec_add(my.vel_x, temp_loc);
	my.alpha = 15 + random(5);
	my.bmap = scatter_map;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.move = on;
	my.function = part_alphafade;
}


//--------------------------------------------------------------------
// Function Local_Effect: continually checks if local effects need done
//--------------------------------------------------------------------
function local_effect()
{
	while(connection == 2) // only client connection needs this function
	{
		if (do_effect_type == EFFECT_HIT_EXPLOSION)
		{
			effect_local(effect_explosion,50,effect_pos.X,effect_normal.x);
			do_effect_type = 0;
		}
		if (do_effect_type == EFFECT_RICOCHET_EXPLOSION)
		{
			effect_local(effect_explosion,20,effect_pos.X,effect_normal.x);
			do_effect_type = 0;
		}

		wait(1);
	}
}

//--------------------------------------------------------------------
// Function Projectile_Event: projectile hit something
//--------------------------------------------------------------------
function projectile_event()
{
	var random_num;
	var dam; // total damage to entity hit
	
	// projectile hit a entity in level
	if(event_type == event_entity)
	{

		// if player hit is not still in grace period
		// check for damage
		if(you.grace_time == 0)
		{

			random_num = int(random(20))+1; // get d20 attack roll
			// check if enemy's AC saved them from hit
			if(random_num >= you.armor_class)
			{
				dam = two_dice_damage(); // do damage for this ammo type
				you.health -= dam; // subtract damage from entity hit
				ptrOwner = ptr_for_handle(my.owned_by_hdl);
				ptrOwner.lunar_psychosis_rating += dam; // give 1 point per damage point
				if(you.health <= 0) // if you killed enemy
				{
					ptrOwner.lunar_psychosis_rating += 500; // give 500 points for kill
				}
				// send needed skills to owner clients
				send_skill(ptrOwner.lunar_psychosis_rating, 0);
				
				// the below sent skills used for local effects on clients
				vec_set(effect_pos.x, my.x); // set explosion position
				send_var(effect_pos);
				vec_set(effect_normal.x,normal); // set explosion normal
				send_var(effect_normal);
				
				do_effect_type = EFFECT_HIT_EXPLOSION; // set effect type
				send_var(do_effect_type);
				
				ent_playsound (my, snd_damage, 100); // play damage sound

				if (connection != 1) // dedicated server need not do local effects
				{
					effect_local(effect_explosion,50,effect_pos.X,effect_normal.x);
				}
			}
			else // richocet
			{
				// the below sent skills used for local effects on clients
				vec_set(effect_pos.x, my.x); // set explosion position
				send_var(effect_pos);
				vec_set(effect_normal.x,normal); // set explosion normal
				send_var(effect_normal);
				
				do_effect_type = EFFECT_RICOCHET_EXPLOSION; // set effect type
				send_var(do_effect_type);
				
				ent_playsound (my, snd_no_damage, 100); // play ricochet sound

				if (connection != 1) // dedicated server need not do local effects
				{
					effect_local(effect_explosion,20,effect_pos.X,effect_normal.x);
				}
			}
		}
	}

	// projectile hit level geometry
	if (event_type == event_block)
	{
		// the below sent skills used for local effects on clients
		vec_set(effect_pos.x, my.x); // set explosion position
		send_var(effect_pos);
		vec_set(effect_normal.x,normal); // set explosion normal
		send_var(effect_normal);
		
		do_effect_type = EFFECT_RICOCHET_EXPLOSION; // set effect type
		send_var(do_effect_type);

		ent_playsound (my, snd_no_damage, 100); // play ricochet sound
		
		if (connection != 1) // dedicated server need not do local effects
		{
			effect_local(effect_explosion,20,effect_pos.X,effect_normal.x);
		}

	}

	my.life_span = 0; // set projectile to dead
}

//--------------------------------------------------------------------
// Function Projectile_Function: create correct projectile for weapon
//--------------------------------------------------------------------
function projectile_function()
{

	my.enable_entity = ON;
	my.enable_block = ON;
	my.event = projectile_event;
	
	my.z += 25; // fire above waist level

	//my.y = you.y + 8 * sin(you.pan) - 8 * cos(you.pan); //offset projectile right
	
	my.speed = PROJECTILE_SPEED; // get speed
	my.pan = you.pan; // set pan to owners pan
	my.force_y = 0;
	my.force_z = 0;
	my.owned_by_hdl = handle(you);
	
	//if player carries nuclear rod 2d18 damage
	if(you.weapon == WEAPON_NUCLEAR_ROD)
	{
		my.life_span = AMMO_LIFESPAN_NUCLEAR; // set range
		my.damage_die_1 = 18; // set die 1 (damage dice)
		my.damage_die_2 = 18; // set die 2
		// play radition beam sound at player
		ent_playsound (you, snd_radiation_beam, 40);
	}

	//if player carries photosynthesis emulator 2d13 damage
	if(you.weapon == WEAPON_PHOTOSYNTHESIS_EMULATOR)
	{
		my.life_span = AMMO_LIFESPAN_EMULATOR; // set range
		my.damage_die_1 = 13; // set die 1 (damage dice)
		my.damage_die_2 = 13; // set die 2
		// play petri dish sound at player
		ent_playsound (you, snd_emulator, 45);
	}

	// if player carries rifle 2d8 damage
	if(you.weapon == WEAPON_COMPRESSION_RIFLE)
	{
		my.life_span = AMMO_LIFESPAN_RIFLE; //set range
		my.damage_die_1 = 8; // set die 1 (damage dice)
		my.damage_die_2 = 8; // set die 2
		// play bullet sound at player
		ent_playsound (you, snd_rifle, 100);
	}

	// while projectile still alive, this is global
	while (my.life_span != 0)
	{
		my.life_span -= 1;
		// use time & speed
		my.force_x = my.speed * time;

		//A5 move
		move_mode = ignore_passable + ignore_you + ignore_me;
		ent_move(my.force_x,nullvector);
		
		//A6.3 move the player, c_move bugged at time of release so using ent_move instead
		//c_move(my, force.x, nullvector, ignore_passable + ignore_you + ignore_me);
		
		wait(1);
	}

	sleep(.1); // wait for sound to be played at projectile
	// if projectile life_span over(at max range), remove projectile
	ent_remove(my);
}


//--------------------------------------------------------------------
// MOVE_PLAYER - Move the player
//--------------------------------------------------------------------
function move_player()
{
	var health_old;
	var trace_vecFrom[3];
	var trace_vecTo[3];

	my.ENABLE_DISCONNECT = ON; // player can disconnect from session
	my.EVENT = player_events; // player events function

	my.nosend_frame = ON; // don't send animation

	my.pan = random(360); // face random direction
	
	my.transparent = ON; // create as transparent until grace period over
	my.alpha = 20;
	my.grace_time = PLAYER_GRACE_TIME; // set time left in grace period
	send_skill(my.grace_time,0);

	
	my.ammunition_remaining = AMMO_GAME_START; // rounds of ammunition at creation
	
	// server gives new player's ent his player number
	number_of_players += 1; // now that new player's entity has been &
	// increment number_of_players
	send_var(number_of_players); // send new number_of_players to all clients
	my.player_number = number_of_players; // set the player_number skill
	send_skill(my.player_number, SEND_ALL); // send player_number skill to all clients

	// this code is to solve high latency creation problem
	sleep(.3); // this can be left at .3 no matter what
	ent_sendnow(my);
	sleep(.3); // sleep(3); // high latency solution for now
	
	// if not client connection
	if(connection != 2)
	{
		if (my.profession == PROF_NUCLEAR_SCIENTIST)
		{
			my.speed = PROF_NUCLEAR_SPEED; // set player speed
			my.health = PROF_NUCLEAR_MAX_HP; // set health
			my.max_health = PROF_NUCLEAR_MAX_HP; // set max health
			my.armor_class = PROF_NUCLEAR_AC; // set AC
			// send health, max-health & armor_class
			send_skill(my.health, SEND_VEC+SEND_ALL);
				
			my.weapon = WEAPON_NUCLEAR_ROD; // set weapon type
			
			you = my; // save me as owner for weapon being created
			// Attach correct weapon to player
			ent_createlocal(str_nuclear_rod, my.X, weapon_local); // created rod at
																		// player position locally

			
			proc_local(my,local_activities_nuclear); // local animation and other activities
		}
	
		if (my.profession == PROF_BIOLOGICAL_SCIENTIST)
		{
			my.speed = PROF_BIOLOGICAL_SPEED; // set player speed
			my.health = PROF_BIOLOGICAL_MAX_HP; // set health
			my.max_health = PROF_BIOLOGICAL_MAX_HP; // set max health
			my.armor_class = PROF_BIOLOGICAL_AC; // set AC
			// send health, max-health & armor_class
			send_skill(my.health, SEND_VEC+SEND_ALL);
				
			my.weapon = WEAPON_PHOTOSYNTHESIS_EMULATOR; // set wepaon
			
			you = my; // save me as owner for weapon being created
			// Attach correct weapon to player
			ent_createlocal(str_emulator, my.X, weapon_local); // created emulator at
																	// player position locally
			
			proc_local(my,local_activities_bio); // local animation and other activities
		}
	
		if (my.profession == PROF_OPERATIONS_OFFICER)
		{
			my.speed = PROF_OFFICER_SPEED; // set player speed
			my.health = PROF_OFFICER_MAX_HP; // set health
			my.max_health = PROF_OFFICER_MAX_HP; // set max health
			my.armor_class = PROF_OFFICER_AC; // set ac
			// send health, max-health & armor_class
			send_skill(my.health, SEND_VEC+SEND_ALL);
			
			my.weapon = WEAPON_COMPRESSION_RIFLE; // set weapon type
			
			you = my; // save me as owner for weapon being created
			// Attach correct weapon to player
			ent_createlocal(str_rifle, my.X, weapon_local); // created rifle at
																// player position locally

			proc_local(my,local_activities_officer); // local animation and other activities
		}
	}

	// if Host animate for Host or single player, dedicated server needs not animate for itself
	if ((connection == 3) || (connection == 0))
	{
		animate(); // animate entity
	}

	while(my.health > 0) // while this entity is alive
	{
		
		// if integer health change since last frame send it to client
		if(int(my.health) != health_old)
		{
			send_skill(my.health,0); //send changed health to client owner
		}
		
		health_old = int(my.health); // save old health for next frame
		
		// Resting code
		// if standing
		if ((my.force_x == 0)&&(my.force_y == 0))
		{
			my.health += .005; // add some health
			if(my.health > my.max_health)
			{
				my.health = my.max_health;
			}
		}
		
		// Exhaustion code
		// if running
		if(abs(my.force_x) > 1)
		{
			my.health -= .02; // subtract some health
			if(my.health < 1) // don't let player run himself to death
			{
				my.health = 1;
			}
		}


		// I am in grace period, amke sure everyone knows that and make me
		// transparent until I can be hit
		if(my.grace_time)
		{
			my.grace_time -= 1; // decrement grace time
			
			// make player more visible
			my.alpha = 20 + ((PLAYER_GRACE_TIME-my.grace_time)/PLAYER_GRACE_TIME)*50;
			
			// Oops, grace period over
			if(my.grace_time == 0)
			{
				my.transparent = OFF; // make player totally visible, grace is over
				send_skill(my.grace_time, 0); // make sure client that created ent knows
				// grace period is over
			}
		}

		
		my.prev_anim_state = my.animation_state; // save animation state
		
		// intially set animation to walk, this will be changed below if necessary
		my.animation_state = ANIMATION_STATE_WALK;

		// if moving forward or backwards at walking rate, set animation to walk
		if((abs(my.force_x) > 0) && (abs(my.force_x) <= 1))
		{
			my.animation_state = ANIMATION_STATE_WALK;
		}
		else
		{
			// if moving forward or backwards at run, set animation to run
			if(abs(my.force_x) > 1)
			{
				my.animation_state = ANIMATION_STATE_RUN;
			}
			else
			{
				// if entity is not turning, then all that is left is standing
				if (my.force_y == 0)
				{
					my.animation_state = ANIMATION_STATE_STAND;
				}
			}
		}
		
		// if firing weapon set how long we want attack animation to run
		if(my.firing_weapon == TRUE)
		{
			my.animation_attack_life = 20;
		}
	
		// if still running attack animation, attack animation overides others
		if(my.animation_attack_life > 0)
		{
			my.animation_state = ANIMATION_STATE_ATTACK;
			my.animation_attack_life -= 1;
		}

		
		// if animation state changed, send new animation state to all clients
		// so they can do animation locally
		if(my.animation_state != my.prev_anim_state)
		{
			send_skill(my.animation_state,SEND_ALL);
		}

		
		// get new pan
		my.pan = my.force_y * PLAYER_SPEED_TURN * time + my.pan;
		
		// use time & speed_forwards_factor
		force.x = my.force_x * my.speed * time;
		force.y = 0;
		force.z = 0;
	
		trace_vecTo.x = my.x + (force.x*2) * cos(my.pan);
		trace_vecTo.y = my.y + (force.x*2) * sin(my.pan);
		trace_vecTo.z = my.z;

		//A5 trace
		trace_mode = ignore_passable + ignore_passents + ignore_me + use_box;
		trace(my.X, trace_vecTo);
		
		//A6.3 trace
		//c_trace(my.X, trace_vecTo, ignore_passable + ignore_passents + ignore_me + use_box);
		
		// if hit something check if it should be passable or not
		if(you)
		{
			if((my.ammunition_remaining == AMMO_MAX)&&(my.health == my.max_health))
			{
				// A5 move
				move_mode = glide + ignore_passable + ignore_passents + ignore_you;
				ent_move(force.x,nullvector);
				
				//A6.3 move the player, c_move bugged at time of release so using ent_move instead
				//c_move(my, force.x, nullvector, glide + ignore_passable + ignore_passents + ignore_you);
			}
			else
			{
				if(you.power_up_type == POWER_UP_LUNAR_CANDY)
				{
					if(my.health < my.max_health)
					{
						// A5 move
						move_mode = glide + ignore_passable + ignore_passents;
						ent_move(force.x,nullvector);
						
						//A6.3 move the player, c_move bugged at time of release so using ent_move instead
						//c_move(my, force.x, nullvector, glide + ignore_passable + ignore_passents);
					}
					else
					{
						// A5 move
						move_mode = glide + ignore_passable + ignore_passents + ignore_you;
						ent_move(force.x,nullvector);
						
						// A6.3 move the player, c_move bugged at time of release so using ent_move instead
						//c_move(my, force.x, nullvector, glide + ignore_passable + ignore_passents + ignore_you);
					}
				}
				else // power up is ammo
				{
					if ((((my.weapon == WEAPON_COMPRESSION_RIFLE) && (you.power_up_type == POWER_UP_AMMUNITION_CARTRIDGE))
					|| ((my.weapon == WEAPON_NUCLEAR_ROD) && (you.power_up_type == POWER_UP_USED_NUCLEAR_FUEL))
					|| ((my.weapon == WEAPON_PHOTOSYNTHESIS_EMULATOR) && (you.power_up_type == POWER_UP_PHOTOSYNTHESIS_JELLY)))
					&& (my.ammunition_remaining < AMMO_MAX))
					{
						// A5 move
						move_mode = glide + ignore_passable + ignore_passents;
						ent_move(force.x,nullvector);
						
						//A6.3 move the player, c_move bugged at time of release so using ent_move instead
						//c_move(my, force.x, nullvector, glide + ignore_passable + ignore_passents);
					}
					else
					{
						// A5 move
						move_mode = glide + ignore_passable + ignore_passents + ignore_you;
						ent_move(force.x,nullvector);
						
						// A6.3 move the player, c_move bugged at time of release so using ent_move instead
						//c_move(my, force.x, nullvector, glide + ignore_passable + ignore_passents + ignore_you);
					}
				}
			}
		}
		else
		{
			// A5 move
			move_mode = glide + ignore_passable + ignore_passents;
			ent_move(force.x,nullvector);
			
			//A6.3 move the player, c_move bugged at time of release so using ent_move instead
			//c_move(my, force.x, nullvector, glide + ignore_passable + ignore_passents);
		}

	
		// A6.3 feature my.floor_dist to scan the floor and to set entity onto the floor
		if(MY.FLOOR_DIST > (MY.MAX_Z - MY.MIN_Z)/2)
		{
			MY.Z -= MY.FLOOR_DIST - (MY.MAX_Z - MY.MIN_Z)/2;
		}
		
		/* A5 scan floor;
		// scan for floor if we are moving
		if (my.force_x || my.force_y || my.force_z)
		{
			//Scan floor pre A6.30
			trace_mode = IGNORE_SPRITES + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS + USE_BOX;
			vec_set(vecFrom,my.X);
			vec_set(vecTo,my.X);
			vecTo.z -= 400;
			RESULT = TRACE(vecFrom,vecTo);
			my.Z = TARGET.Z + ((my.MAX_Z - my.MIN_Z)/2);//Set to the floor
		}
		*/
		
		// if ent just hit attack key, create projectile depending on weapon
		if (my.firing_weapon == TRUE)
		{
			if(my.weapon == WEAPON_NUCLEAR_ROD)
			{
				ent_create(str_radiation_beam, my.X, projectile_function);
			}
			
			if (my.weapon == WEAPON_PHOTOSYNTHESIS_EMULATOR)
			{
				ent_create(str_petri_dish, my.X, projectile_function);
			}
			
			if (my.weapon == WEAPON_COMPRESSION_RIFLE)
			{
				ent_create(str_bullet, my.X, projectile_function);
			}
			
			my.firing_weapon = FALSE; // projectile sent, no longer firing
		}
		
		wait(1);
	}
	
	number_of_players -= 1; // decrement number of players
	player_number_quit = my.player_number; // save player number who was killed
	// Go through all entities, any player# that was above mine, decrement his player number
	you = ent_next(NULL);
	while(you != NULL)
	{
		if(you.player_number > player_number_quit)
		{
			you.player_number -= 1;
			send_skill(you.player_number, SEND_ALL); // send new player#
		}
		you =ent_next(you);
	}

	send_var(number_of_players); // let everyone know new number of players
	ent_remove(my); // remove ent of player that died
}

//--------------------------------------------------------------------
// MOVE CAMERA - Simple 3rd Person Chase camera
//--------------------------------------------------------------------
function move_camera()
{
	
	var distance;
	var adj_cam_tilt;
	var camera_next[3];
	
	restart_camera:
	
	// wait for player to be created
	while (player == NULL)
	{
		wait (1);
	}
	
	
	while (player != NULL) // player exist? 
	{

		camera_next.x = player.x - cos (player.pan) * 200;
		camera_next.y = player.y - sin (player.pan) * 200;
		camera_next.z = player.z + 5;
		
		you = player;
		
		// make sure camera has unobstructed view
		trace_mode = IGNORE_SPRITES + IGNORE_YOU + IGNORE_PASSABLE + USE_BOX;
		distance = TRACE(player.x,camera_next.x);
		if (distance)
		{
			distance -= 2;
			camera.x = player.x - cos (player.pan) * distance;
			camera.y = player.y - sin (player.pan) * distance;
		}
		else
		{
			camera.x = player.x - cos (player.pan) * 200;
			camera.y = player.y - sin (player.pan) * 200;
		}

		camera.z = player.z + 75;
		camera.pan = player.pan;
		if(distance==0)
		{
			distance = 200;
		}
		
		// if players back close to wall, tilt camera down some so we can see
		// player as long as possible and still be able to see
		// play field
		
		adj_cam_tilt = (100/distance);
	

		if(adj_cam_tilt > 1.75)
		{
			adj_cam_tilt = 1.75;
		}
		
		camera.tilt = -10;
		camera.tilt += (camera.tilt*adj_cam_tilt);
		adj_cam_tilt = 0;
		camera.roll = 0;
		
		wait (1);
	}

	goto(restart_camera);
}


//--------------------------------------------------------------------
// CREATE PLAYER - create player at random location
//--------------------------------------------------------------------
function create_player()
{
	var position_found = FALSE;

	while (position_found == FALSE)
	{
		// get random start vector around center of level
		vecFrom.x =-400 + random(800);
		vecFrom.y =-400 + random(800);
		vecFrom.z = 200;

		vec_set(vecTo,VecFrom);
		vecTo.z = -200;

		trace_mode = IGNORE_SPRITES + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS + USE_BOX + SCAN_TEXTURE;
		TRACE(vecFrom,vecTo);

		// check for floor texture, if floor create entity
		if((str_stri(tex_name,"earthtile") != FALSE)||(str_stri(tex_name,"crator") != FALSE))
		{

			vec_set(temp_loc,vecTo);
			temp_loc.z = target.z + 35;
			
			// create player's entity depending on profession
			if (profession_ID == PROF_NUCLEAR_SCIENTIST)
			{
				player = ent_create(str_warlock,temp_loc,move_nuclear);
			}
			
			if (profession_ID == PROF_BIOLOGICAL_SCIENTIST)
			{
				player = ent_create(str_guard,temp_loc,move_biological);
			}

			if (profession_ID == PROF_OPERATIONS_OFFICER)
			{

				player = ent_create(str_cbabe,temp_loc,move_officer);	
			}

			position_found = TRUE; // found floor to create player on
		}
	}
}

//--------------------------------------------------------------------
// Function Set_Prof_Nuclear: Player chose nuclear scientist
//--------------------------------------------------------------------
function set_prof_nuclear()
{
	profession_ID = PROF_NUCLEAR_SCIENTIST;
	profession_not_set = FALSE;
}

//--------------------------------------------------------------------
// Function Set_Prof_Biological: Player chose biological scientist
//--------------------------------------------------------------------
function set_prof_biological()
{
	profession_ID = PROF_BIOLOGICAL_SCIENTIST;
	profession_not_set = FALSE;
}

//--------------------------------------------------------------------
// Function Set_Prof_Officer: Player chose operations officer
//--------------------------------------------------------------------
function set_prof_officer()
{
	profession_ID = PROF_OPERATIONS_OFFICER;
	profession_not_set = FALSE;
}

//--------------------------------------------------------------------
// Function Init_Display: set-up text positions according to screen size
//--------------------------------------------------------------------
function init_display()
{
	pnlTitle.pos_y = screen_size.y/2 + 100;
	pnlTitle.pos_x = screen_size.x/2 - 150;
	pnlTitle.alpha = 75;
	pnlSelect.pos_y = screen_size.y/2 - 100;
	pnlSelect.pos_x = screen_size.x/2 - 150;
	pnlSelect.alpha = 75;

	pnlBiological.pos_y = screen_size.y/2;
	pnlBiological.pos_x = screen_size.x/2 - 300;
	pnlBiological.alpha = 75;
	pnlNuclear.pos_y = screen_size.y/2;
	pnlNuclear.pos_x = screen_size.x/2 - 75;
	pnlNuclear.alpha = 75;
	pnlOfficer.pos_y = screen_size.y/2;
	pnlOfficer.pos_x = screen_size.x/2 + 150;
	pnlOfficer.alpha = 75;
	
	txt_people_connected.pos_x = screen_size.x - 350;
	txt_player_number.pos_x = screen_size.x - 350;
	txt_number_of_players.pos_x = screen_size.x - 350;
	txt_latency.pos_x = screen_size.x - 350;
	txt_bps.pos_x = screen_size.x - 350;
	txt_status_message.pos_x = screen_size.x/2 - 150;
	txt_status_message.pos_y = screen_size.y/2;


}

function input_scan()
{
	// only send changed skill values, so we need variable to store old values
	var force_x_old;
	var force_y_old;

	while (1)
	{
		// if player has been created get inputs for him
		if (player)
		{
			force_x_old = player.force_x; //store old force values
			force_y_old = player.force_y;
			
			player.force_x = 0; // set force to 0 until we get key input
			player.force_y = 0;
		
			// <w> or <cursur up> moves forward
			if ((key_w == 1)||(key_cuu == 1))
			{
				player.force_x = 1;
			}
			// <a> or <cursor left> turns left
			if ((key_a == 1)||(key_cul == 1))
			{
				player.force_y = 1;
			}
			// <d> or <cursor right> turns right
			if ((key_d == 1)||(key_cur == 1))
			{
				player.force_y = -1;
			}
			// <s> or <cursor left> moves back
			if ((key_s == 1)||(key_cud == 1))
			{
				player.force_x = -1;
			}
			
			// <shift> for run
			if (key_shift == 1)
			{
				player.force_x = player.force_x * 1.5; // run is 1.5 times faster than walk
			}

			// The Code below uses 3DGS's force protocol
			// get new force values (gruadually speed up force)
			// uses more bandwidth until reaches min or max force
			// but does work

			//player.force_x = key_force.y; // get force x
			//player.force_y = -key_force.x; // get force y
			//player.force_z = 0; // force z always 0 for now
			
			// if any forces have changed, send new forces to server
			if(player.force_x != force_x_old || player.force_y != force_y_old)
			{
				// if client, send forces to server, if we are single/host/server values need not
				// be sent
				if(connection == 2)
				{
					send_skill(player.force_x,SEND_VEC); // send force vec to server
				}
			}		
		}
		wait(1);
	}
}

//--------------------------------------------------------------------
// Init_Chat - Initializ chat panel
//--------------------------------------------------------------------
function init_chat()
{
	// if host or client set up chat
	if (connection == 2 || connection == 3)
	{
		pnlChat.pos_y = screen_size.y - 100;
		txtChat.pos_y = screen_size.y - 100;
		txtChatEntry.pos_y = screen_size.y - 15;
		pnlChat.visible = ON;
		txtChat.visible = ON;
		txtChatEntry.visible = OFF;
	}
}

//--------------------------------------------------------------------
// Chat_Entry - get chat input from player
//--------------------------------------------------------------------
function chat_entry()
{

	// if host or client
	if (connection == 2 || connection == 3)
	{
		// if inkey already open return
		if (inkey_active == TRUE)
		{
			return;
		}
		
		txtChatEntry.visible = ON;
		inkey(strChatEntry); // get chat entry
		
		// if entry was empty don't process
		if(str_cmp(strChatEntry,""))
		{
			return;
		}
		txtChatEntry.visible = OFF;
		str_cpy(strSendChat,player_name); // put players name before entry
		str_cat(strSendChat,": ");
		str_cat(strSendChat,strChatEntry);
		// if Host go ahead and do chat manipulation
		if (connection == 3)
		{
			send_string(strSendChat);
			str_cpy(strChat0, strChat1);
			str_cpy(strChat1, strChat2);
			str_cpy(strChat2, strChat3);
			str_cpy(strChat3, strChat4);
			str_cpy(strChat4, strChat5);
			str_cpy(strChat5, strChat6);
			str_cpy(strChat6, strChat7);
			str_cpy(strChat7, strChat8);
			str_cpy(strChat8, strSendChat);
			str_cpy(strSendChat,"");
		}
		else // if client send entry to server for processing
		{
			send_string(strSendChat);
		}
		str_cpy(strSendChat,""); // clear the strings for client and
		str_cpy(strChatEntry,""); // server called functions
	}
}

//--------------------------------------------------------------------
// Function Ammo_Event: ammunition power-up touched, see if it needs
// picked up
//--------------------------------------------------------------------
function ammo_event()
{
	// if player holding rifle and ammo is ammunition cartridge
	// player picks it up
	if ((you.weapon == WEAPON_COMPRESSION_RIFLE) && (my.power_up_type == POWER_UP_AMMUNITION_CARTRIDGE))
	{
		// only can pick-up if ammo not full
		if (you.ammunition_remaining < AMMO_MAX)
		{
			// add up to 15 rounds of ammo
			you.ammunition_remaining += int(random(15)) + 1;
			// if over max ammo, set to max ammo
			if (you.ammunition_remaining > AMMO_MAX)
			{
				you.ammunition_remaining = AMMO_MAX;
			}
	
			// play power-up sound at ent
			ent_playsound (you, snd_power_up, 60);
			// send ammo remaining to clients
			send_skill(you.ammunition_remaining, 0);
			ammo_cartridge_count -= 1; // 1 less cartridge in level
			ent_remove(my); // remove ammo
		}
	}
	else
	{
		// if player holding nuclear rod and ammo is nuclear fuel
		/// player picks it up
		if ((you.weapon == WEAPON_NUCLEAR_ROD) && (my.power_up_type == POWER_UP_USED_NUCLEAR_FUEL))
		{
			// only can pick-up if ammo not full
			if (you.ammunition_remaining < AMMO_MAX)
			{
				// add up to 15 rounds of ammo
				you.ammunition_remaining += int(random(15)) + 1;
				// if over max ammo, set to max ammo
				if (you.ammunition_remaining > AMMO_MAX)
				{
					you.ammunition_remaining = AMMO_MAX;
				}
				// play power-up sound at ent
				ent_playsound (you, snd_power_up, 60);
				// send ammo remaining to clients
				send_skill(you.ammunition_remaining, 0);
				nuclear_fuel_count -= 1; // 1 less nuke fuel in level
				ent_remove(my); // remove ammo
			}
		}
		else
		{
			if ((you.weapon == WEAPON_PHOTOSYNTHESIS_EMULATOR) && (my.power_up_type == POWER_UP_PHOTOSYNTHESIS_JELLY))
			{
				// only can pick-up if ammo not full
				if (you.ammunition_remaining < AMMO_MAX)
				{
					you.ammunition_remaining += int(random(15)) + 1;
					// if over max ammo, set to max ammo
					if (you.ammunition_remaining > AMMO_MAX)
					{
						you.ammunition_remaining = AMMO_MAX;
					}
					// play power-up sound at ent
					ent_playsound (you, snd_power_up, 60);
					// send ammo remaining to clients
					send_skill(you.ammunition_remaining, 0);
					photo_jelly_count -= 1; // 1 less jelly in level
					ent_remove(my); // remove ammo
				}
			}
		}
	}
}

//--------------------------------------------------------------------
// Function Ammo_Function: set-up ammunition power-ups
//--------------------------------------------------------------------
function ammo_function()
{
	my.ENABLE_IMPACT = ON; // event for hit by another moving entity
	my.EVENT = ammo_event; // event function

	
	//*** A6.3 feature my.floor_dist to scan the floor and to set entity onto the floor
	if(MY.FLOOR_DIST > (MY.MAX_Z - MY.MIN_Z)/2)
	{
		MY.Z -= MY.FLOOR_DIST - (MY.MAX_Z - MY.MIN_Z)/2;
	}
	
	/* A5 scan floor;
	// scan for floor if we are moving
	if (my.force_x || my.force_y || my.force_z)
	{
	//Scan floor pre A6.30
	trace_mode = IGNORE_SPRITES + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS + USE_BOX;
	vec_set(vecFrom,my.X);
	vec_set(vecTo,my.X);
	vecTo.z -= 400;
	RESULT = TRACE(vecFrom,vecTo);
	my.Z = TARGET.Z + ((my.MAX_Z - my.MIN_Z)/2);//Set to the floor
	}
	*/


	my.z -= 30; // model box adjustment for ammo
}

//--------------------------------------------------------------------
// Function Candy_Event: lunar_candy(health) power-up touched,add some health
//--------------------------------------------------------------------
function candy_event()
{
	// if touched lunar candy and not at max health
	if (you.health < you.max_health)
	{
		// add health
		you.health += int(random(10) + you.max_health/10);
		
		// if over max health, set to max health
		if(you.health > you.max_health)
		{
			you.health = you.max_health;
		}
		// play power-up sound ant ent
		ent_playsound (you, snd_power_up, 60);
		send_skill(you.health,SEND_ALL); // send new health to clients
		lunar_candy_count -= 1; // 1 less lunar candy in level
		ent_remove(my); // remove lunar candy
	}
}


//--------------------------------------------------------------------
// Function Candy_Function: set-up lunar candy power-ups
//--------------------------------------------------------------------
function candy_function()
{
	my.ENABLE_IMPACT = ON; // event for hit by another moving entity
	my.EVENT = candy_event; // event function

	//*** A6.3 feature my.floor_dist to scan the floor and to set entity onto the floor
	if(MY.FLOOR_DIST > (MY.MAX_Z - MY.MIN_Z)/2)
	{
		MY.Z -= MY.FLOOR_DIST - (MY.MAX_Z - MY.MIN_Z)/2;
	}
	/* A5 scan floor;
	// scan for floor if we are moving
	if (my.force_x || my.force_y || my.force_z)
	{
	//Scan floor pre A6.30
	trace_mode = IGNORE_SPRITES + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS + USE_BOX;
	vec_set(vecFrom,my.X);
	vec_set(vecTo,my.X);
	vecTo.z -= 400;
	RESULT = TRACE(vecFrom,vecTo);
	my.Z = TARGET.Z + ((my.MAX_Z - my.MIN_Z)/2);//Set to the floor
	}
	*/
	
	my.z -= 25;
}

//--------------------------------------------------------------------
// Function Create_Power_Up: create a random power-up
//--------------------------------------------------------------------
function create_power_up()
{
	var random_number;
	var position_found = FALSE; // have we found the floor?
	
	// while floor not found try new random vector for creation
	while (position_found == FALSE)
	{
		// get random start place in middle of level
		vecFrom.x =-550 + random(1100);
		vecFrom.y =-550 + random(1100);
		vecFrom.z = 200;
		
		// get where to trace to
		vec_set(vecTo,VecFrom);
		vecTo.z = -200;
		
		// trace checking for texture hit
		trace_mode = IGNORE_SPRITES + IGNORE_PASSENTS + IGNORE_PASSABLE + IGNORE_MODELS + SCAN_TEXTURE + USE_BOX;
		TRACE(vecFrom,vecTo);
		
		// if we hit floor's texture than place power-up there
		if(str_stri(tex_name,"earthtile") != FALSE)
		{
			position_found = TRUE; // we have now found the floor so set power-up
			//type if that type not maxed
			
			// set origin position
			vec_set(temp_loc,vecTo);
			temp_loc.z = 25;
			// get random power-up type
			random_number = int(random(10)) + 1;
			
			// 7 - 10 = Lunar_Candy - if level not full of them, create 1
			if ((random_number >= 7) && (lunar_candy_count <= 10))
			{
				ptrTempEnt = ent_create(str_lunar_candy,temp_loc,candy_function);
				ptrTempEnt.power_up_type = POWER_UP_LUNAR_CANDY;
				lunar_candy_count += 1; // increment lunar candies in level
				goto(created_power_up);
			}

			// 5 - 6 = Photosynthesis Jelly - if level not full of them, create 1
			if ((random_number >= 5) && (photo_jelly_count <= 10))
			{
				ptrTempEnt = ent_create(str_photo_jelly,temp_loc,ammo_function);
				ptrTempEnt.power_up_type = POWER_UP_PHOTOSYNTHESIS_JELLY;
				photo_jelly_count += 1; // increment photo jellies in level
				goto(created_power_up);
			}

			// 3 - 4 = Nuclear Rod - if level not full of them, create 1
			if ((random_number >= 3) && (nuclear_fuel_count <= 10))
			{
				ptrTempEnt = ent_create(str_nuclear_fuel,temp_loc,ammo_function);
				ptrTempEnt.power_up_type = POWER_UP_USED_NUCLEAR_FUEL;
				nuclear_fuel_count += 1; // increment nuclear fuels in level
				goto(created_power_up);
			}

			// 1 - 2 = Ammo Catridge - if level not full of them, create 1
			if ((random_number >= 1) && (ammo_cartridge_count <= 10))
			{
				ptrTempEnt = ent_create(str_ammo_cartridge,temp_loc,ammo_function);
				ptrTempEnt.power_up_type = POWER_UP_AMMUNITION_CARTRIDGE;
				ammo_cartridge_count += 1; // increment ammo cartridges in level
			}
			
			created_power_up:

		}
	}
}




//--------------------------------------------------------------------
// Function Spawn_Power_Ups: randomly create power-ups
//--------------------------------------------------------------------
function spawn_power_ups()
{
	var random_number;
	
	while(1)
	{
		randomize();
		random_number = int(random(1000)) + 1;
		// the more players in game, the more likely a power-up is spawned
		if (random_number > (999 - number_of_players))
		{
			create_power_up(); // place a power up into level
		}
		wait(1);
	}
}

//--------------------------------------------------------------------
// Fire_Weapon - player hit key to fire weapon, so let server know
//--------------------------------------------------------------------
function fire_weapon()
{
	// fire weapon if have ammo, not reloading and not in grace peiod
	if ((player.ammunition_remaining > 0) && (weapon_recharge_count == WEAPON_RECHARGE_DELAY)
	&& (player.grace_time == 0))
	{
		weapon_recharge_count = 0; // set reload timer to 0
		player.ammunition_remaining -= 1; // one less round ammo
		player.firing_weapon = TRUE; // player is firing weapon
		if (connection == 2) // client?
		{
			send_skill(player.ammunition_remaining,0); // send ammo left to server
			send_skill(player.firing_weapon,0); // let server know we are firing weapon
		}
	}
}

//--------------------------------------------------------------------
// Function Reload_Weapon(): reload weapon (time inbetween attacks)
//--------------------------------------------------------------------
function reload_weapon()
{
	while(1)
	{
		weapon_recharge_count += 1;
		if(weapon_recharge_count > WEAPON_RECHARGE_DELAY)
		{
			weapon_recharge_count = WEAPON_RECHARGE_DELAY;
		}
		wait(1);
	}
}

on_server = server_called; // on server event, call server_called()
on_client = client_called; // on client event, call cleint_called()
on_enter = chat_entry; // on <enter> start chat entry
on_space = fire_weapon; // on <space> shoot weapon



function save_screen()
{
	screenshot("Multiplayer",1);
}
on_p = save_screen; // on 's' key save screenshot